﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;
using System.Windows.Forms;

namespace pr282_1
{
    // Класс окна: 
    class MyForm: Form {
        // Ссылка на объект для рисования:
        Pen p;
        // Ссылка на объект графического контекста:
        Graphics g;
        // Конструктор: 
        public MyForm(): base() {
            // Размеры окна: 
            this.Width = 325;
            this.Height = 380;
            // Окно фиксированных размеров: 
            this.FormBorderStyle = FormBorderStyle.FixedToolWindow;
            // Заголовок окна: 
            this.Text = "Координаты курсора";
            // Объект метки:
            Label lbl = new Label();
            // Размеры метки:
            lbl.Width = 300;
            lbl.Height = 30;
            // Положение метки: 
            lbl.Location = new Point(5,5);
            // Рамка для метки: 
            lbl.BorderStyle = BorderStyle.Fixed3D;
            // Шрифт для метки:
            lbl.Font = new Font("Arial", 10, FontStyle.Bold);
            // Способ выравнивания текста в метке: 
            lbl.TextAlign = ContentAlignment.MiddleCenter;
            // Добавление метки в окно: 
            this.Controls.Add(lbl);
            // Объект панели:
            Panel pnl = new Panel();
            // Размеры панели:
            pnl.Width = lbl.Width;
            pnl.Height = 300;
            // Положение панели:
            pnl.Top = lbl.Bottom + 5;
            pnl.Left = lbl.Left;
            // Рамка для панели: 
            pnl.BorderStyle = BorderStyle.Fixed3D;
            // Цвет панели:
            pnl.BackColor = Color.Yellow;
            // Вид курсора над панелью: 
            pnl.Cursor = Cursors.Hand;
            // Объект для рисования: 
            p = new Pen(Color.Blue, 3);
            // Объект графического контекста для панели: 
            g = pnl.CreateGraphics();
            // Обработчик события, связанного с движением курсора 
            // над областью панели: 
            pnl.MouseMove += (obj, ea) => {
                // Перерисовка панели: 
                pnl.Refresh();
                // Текст для метки: 
                lbl.Text = "Горизонталь: " + ea.X; 
                lbl.Text += "     ";
                lbl.Text += "Вертикаль: " + ea.Y;
                // Отображение линий:
                g.DrawLine(p, new Point(0, ea.Y), new Point(pnl.ClientSize.Width, ea.Y)); 
                g.DrawLine(p, new Point(ea.X, 0), new Point(ea.X, pnl.ClientSize.Height));
            };
            // Обработчик события, связанного с перемещением 
            // курсора за пределы панели: 
            pnl.MouseLeave += (obj, ae) => {
                // Текст для метки: 
                lbl.Text = "";
                // Перерисовка панели: 
                pnl.Refresh();
            };
            // Добавление панели в окно: 
            this.Controls.Add(pnl);
        }
        // Деструктор:
        ~MyForm() {
            // Освобождение ресурсов, задействованных
            // для рисования:
            g.Dispose();
            p.Dispose();
        }
    }

    // Главный класс: 
    class Programs
    {
        [STAThread]
        // Главный метод: 
        static void Main()
        {
            // Отображение окна:
            Application.Run(new MyForm());
        }
    }
}
